package SCSite::Filter;

use Moo::Role;

requires '_filter_stream';

sub callback_for {
  my ($self, @args) = @_;
  sub {
    my ($stream) = @_;
    my $config = $self->_parse_config($stream->peek);
    $self->_filter_stream($stream, $config, @args)
  }
}

sub _parse_config {
  my ($self, $evt) = @_;
  my %config = ( # adapted from CSS::Tiny, extracts -scs- prefix.
    map /^\s*-scs-([\w._-]+)\s*:\s*(.*?)\s*$/,
      grep { /\S/ } split /\;/, ($evt->{attrs}{style}||'')
  );
  s/^'(.*)'$/$1/ for values %config;
  \%config;
}

1;
